﻿using System;
using System.IO;
using System.Web;
using System.Web.Mvc;

namespace WebPDemo.Helpers
{
    public static class WebPHelper
    {
        public static MvcHtmlString DrawImage(this HtmlHelper helper, string imageUrl, string alt)
        {
            if (CanBrowserHandleWebPImages())
            {
                // Get the file type
                string fileType = Path.GetExtension(imageUrl);
                if (fileType != null)
                {
                    imageUrl = imageUrl.Replace(fileType, ".webp");
                }

                return new MvcHtmlString(String.Format("<img alt=\"{0}\" " + "src=\"{1}\" />", alt, imageUrl));
            }


            return new MvcHtmlString(String.Format("<img alt=\"{0}\" " + "src=\"{1}\" />", alt, imageUrl));
        }

        /// <summary>
        /// Detect if the current browser is capable
        /// of handling WebP images
        /// </summary>
        /// <returns>A boolean based on the result.</returns>
        private static bool CanBrowserHandleWebPImages()
        {
            HttpRequest httpRequest = HttpContext.Current.Request;
            HttpBrowserCapabilities browser = httpRequest.Browser;

            if (browser.Type.Contains("Chrome") || browser.Type.Contains("Opera") || browser.Type.Contains("Android"))
            {
                return true;
            }

            return false;
        }
    }
}